TYPO3-PSA-2019-011: Possible Insecure Deserialization in Extbase Request Handling

  • Component Type: TYPO3 CMS
  • Subcomponent: Extbase Request Handling (ext:extbase)
  • Release Date: December 17, 2019
  • Impact: Possible Insecure Deserialization
  • Affected Versions: All before 10.0.0
  • Severity: none - high
  • Suggested CVSS v3.1:AV:N/AC:H/PR:N/UI:N/S:U/C:H/I:H/A:H/E:F/RL:T/RC:C

Problem Description

It has been discovered that request handling in Extbase can be vulnerable to insecure deserialization. User submitted payload has to be signed with a corresponding HMAC-SHA1 using the sensitive TYPO3 encryptionKey as secret - invalid or unsigned payload is not deserialized.

However, since sensitive information could have been leaked by accident (e.g. in repositories or in commonly known and unprotected backup files), there is the possibility that attackers know the private encryptionKey and are able to calculate the required HMAC-SHA1 to allow a malicious payload to be deserialized.

Requirements for successfully exploiting this vulnerability (all of the following):

  • rendering at least one Extbase plugin in the frontend
  • encryptionKey has been leaked (from LocalConfiguration.php or corresponding .env file)

Solution

Update to TYPO3 versions 8.7.30 or 9.5.12 that fix the problem described.

Credits

Thanks to TYPO3 security team member Oliver Hader who analyzed and fixed the issue.

General Advice

Follow the recommendations that are given in the TYPO3 Security Guide. Please subscribe to the typo3-announce mailing list.

Zurück